
/*
 * Created on 28 avr. 2004
 *
 */
package fr.umlv.sprintabout;

import java.util.*;
import java.lang.reflect.Method;

/**
 * @author remi
 *
 */
class AlgorithmFactory {

  public Algorithm getAlgorithm(Selector selector,final List<Method> impls) {
    return new Algorithm() {
      @Override
      int getMethodCount() {
        return impls.size();
      }
      
      @Override
      int getArgumentCount() {
        return 1;
      }
      
      @Override
      Class<?> getTypeAt(int methodIndex,int argumentIndex) {
        return impls.get(methodIndex).getParameterTypes()[0];
      }
      
      @Override
      int getAnnotationAt(int methodIndex,int argumentIndex) {
        return methodIndex+1;
      }
      
      @Override
      Method getMethodAtDispatchIndex(int dispatchIndex) {
        return impls.get(dispatchIndex);
      }
    };
  }
}
