
/*
 * Created on 28 avr. 2004
 *
 */
package fr.umlv.sprintabout;

import java.lang.reflect.Method;

/**
 * @author remi
 *
 */
class Selector {
  public Selector(Method method) {
    this.name=strip(method.getName());
    this.length=method.getParameterTypes().length;
    this.method=method;
  }
 
  // convenient constructor to lookup in hashmap
  Selector(String name,int length) {
    this.name=name;
    this.length=length;
    this.method=null;
  }
  
  String getMapFieldName(int parameterIndex) {
    return "$map$"+name+"$"+length+"$"+parameterIndex;
  }
  
  String getDispatchName() {
    return "$dispatch$"+name+"$"+length+"$";
  }
  
  @Override
  public int hashCode() {
    return 1 << length ^ name.hashCode();
  }
  
  @Override
  public boolean equals(Object o) {
    Selector selector=(Selector)o;
    return selector.length==length &&
      selector.name.equals(name);
  }
  
  private static String strip(String name) {
    // remove "Appropriates"
    return name.substring(0,name.length()-11);
  }
  
  final Method method;
  final int length;
  final String name;
}
